# Twirl Class Reference

`#include <twirl.h>`

Inheritance diagram for Twirl:

List of all members.

## Public Member Functions

| Twirl ()
virtual bool | set_param (const synfig::String &param, const synfig::ValueBase &value)
| Sets the parameter described by param to value.
virtual synfig::ValueBase | get_param (const synfig::String &param) const
| Get the value of the specified parameter.
virtual synfig::Color | get_color (synfig::Context context, const synfig::Point &pos) const
| Gets the color of the Canvas at pos.
synfig::Layer::Handle | hit_check (synfig::Context context, const synfig::Point &point) const
| Checks to see if a part of the layer is directly under point.
virtual Vocab | get_param_vocab () const
| Gets the parameter vocabulary.
virtual etl::handle < synfig::Transform > | get_transform () const
virtual bool | reads_context () const
| Returns true if the layer needs to be able to examine its context.

## Friends

class | Twirl_Trans

## Constructor & Destructor Documentation

Twirl::Twirl | ( |  | ) |

## Member Function Documentation

bool Twirl::set_param | ( | const synfig::String & | param,
|  | const synfig::ValueBase & | value |
| ) |  |  | `[virtual]`

Sets the parameter described by param to value.

Parameters:

  | param | The name of the parameter to set
  | value | What the parameter is to be set to.

Returns:
  `true` on success, `false` upon rejection or failure. If it returns `false`, then the Layer is assumed to remain unchanged.

See also:
  get_param()

Todo:
  param should be of the type `const String &param`

Reimplemented from synfig::Layer_Composite.

References IMPORT.

ValueBase Twirl::get_param | ( | const synfig::String & | param | ) | const`[virtual]`

Get the value of the specified parameter.

Returns:
  The requested parameter value, or (upon failure) a NIL ValueBase.

See also:
  set_param()

Todo:
  param should be of the type `const String &`

Reimplemented from synfig::Layer_Composite.

References EXPORT, EXPORT_NAME, and EXPORT_VERSION.

Color Twirl::get_color | ( | synfig::Context | context,
|  | const synfig::Point & | pos |
| ) |  |  | const`[virtual]`

Gets the color of the Canvas at pos.

Parameters:

  | context | Context iterator referring to next Layer.
  | pos | Point which indicates where the Color should come from

See also:
  Handle::get_color()

Reimplemented from synfig::Layer.

References synfig::Context::get_color().

synfig::Layer::Handle Twirl::hit_check | ( | synfig::Context | context,
|  | const synfig::Point & | point |
| ) |  |  | const`[virtual]`

Checks to see if a part of the layer is directly under point.

Parameters:

  | context | Context iterator referring to next Layer.
  | point | The point to check

Returns:
  The handle of the layer under point. If there is not a layer under point, then returns an empty handle.

Reimplemented from synfig::Layer.

References synfig::Context::hit_check().

Layer::Vocab Twirl::get_param_vocab | ( | void |  | ) | const`[virtual]`

Gets the parameter vocabulary.

Reimplemented from synfig::Layer_Composite.

References _, and synfig::Layer::set_description().

etl::handle< Transform > Twirl::get_transform | ( |  | ) | const`[virtual]`

Todo:
  This needs to be documented further.

Reimplemented from synfig::Layer.

References Twirl_Trans.

virtual bool Twirl::reads_context | ( |  | ) | const`[inline, virtual]`

Returns true if the layer needs to be able to examine its context.

context to render itself, other than for simple blending. For example, the blur layer will return true - it can't do its job if it can't see its context, and the circle layer will return false - rendering a circle doesn't depend on the underlying context until the final blend operation.

Reimplemented from synfig::Layer.

## Friends And Related Function Documentation

friend class Twirl_Trans`[friend]`

Referenced by get_transform().

The documentation for this class was generated from the following files:

- twirl.h
- twirl.cpp